        CPU   "Z180.TBL"
        HOF   "INT8"

        ORG   8000H
CNTR    EQU   0AH
TRDR    EQU   0BH
CNTLA0  EQU   0
;
;/* example send 'P' to digit 1 /*

        LD    DE,167H       ;P
        CALL  SHIFT
        RST   18H
;
;***********************
;      SEND TO 7219    *
;***********************
; I/P = DE (D= DIGIT, E=DATA)
; O/P = ABDE

SHIFT:  IN0   A,(CNTLA0)
        RES   4,A
        OUT0  (CNTLA0),A
        CALL  MSB
;
        CALL  SEND_CSIO
        LD    D,E
        CALL  SEND_CSIO
;
        SET   4,A
        OUT0  (CNTLA0),A
        RES   4,A
        OUT0  (CNTLA0),A
        RET
;
;***********************
;     SEND CSIO SUB.   *
;***********************
; I/P = D

SEND_CSIO
        PUSH  AF
SEND_C1 IN0   A,(CNTR)
        BIT   4,A
        JR    NZ,SEND_C1
        OUT0  (TRDR),D
        SET   4,A
        OUT0  (CNTR),A
SEND_C2 IN0   A,(CNTR)
        BIT   4,A
        JR    NZ,SEND_C2
        POP   AF
        RET
;
;***********************
;   ROTATE LSB -> MSB  *
;***********************
; I/P = DE
; O/P = DE
; REG = ABDE

MSB     PUSH  AF
        LD    B,8
MSB1    RRC   D
        RL    A
        DJNZ  MSB1
        LD    D,A
        LD    B,8
MSB2    RRC   E
        RL    A
        DJNZ  MSB2
        LD    E,A
        POP   AF
        RET
;
;***********************
;     INITIAL 7219     *
;***********************

INIT:   LD    A,10H
        OUT0  (CNTR),A

        LD    DE,0A08H
        CALL  SHIFT
        LD    DE,0B05H
        CALL  SHIFT
        LD    DE,0900H
        CALL  SHIFT
        LD    DE,0C01H
        CALL  SHIFT
        LD    DE,0F00H
        CALL  SHIFT
        RET



